#include <stdio.h>
#include <errno.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/udp.h>
#include <linux/icmp.h>
#include <linux/if.h>
#include <sys/param.h>
#include <net/ip_nat.h>

#define CMD_NONE		0x0000
#define CMD_DELETE		0x0001
#define CMD_INSERT		0x0002
#define CMD_APPEND		0x0004
#define CMD_LIST		0x0008
#define CMD_FLUSH		0x0010

#define OPT_NONE		0x000000
#define OPT_NUMERIC		0x000001
#define OPT_SOURCE		0x000002
#define OPT_DESTINATION		0x000004
#define OPT_PROTOCOL		0x000008
#define OPT_VIAADDR		0x000010
#define OPT_VIANAME		0x000020
#define OPT_SKIP		0x000040
#define OPT_BIDIR		0x000080
#define OPT_VERBOSE		0x000100
#define OPT_PRINTK		0x000200
#define OPT_IN			0x000400
#define OPT_OUT			0x000800
#define OPT_SRC_NATADDR		0x001000
#define OPT_DST_NATADDR		0x002000
#define OPT_ID			0x004000
#define OPT_VIRTUAL_SERVER	0x008000
#define OPT_WEIGHT		0x010000
#define OPT_TIMEOUT		0x020000


extern char package_version[];
extern char *sports[IP_NAT_MAX_PORTS];
extern char *dports[IP_NAT_MAX_PORTS];
extern char *shostnetworkmask, *dhostnetworkmask, *new_shostnetworkmask, *new_dhostnetworkmask;
extern struct ip_nat_set nat_set;
extern int command;
extern long options;
extern int timeout;
extern int nsaddrs, ndaddrs;
extern struct in_addr *saddrs, *daddrs;


extern struct in_addr *parse_hostnetwork(char *, int *);
extern long string_to_number(char *, long, long);
extern int parse_timeout(char *);
extern void parse_protocol(char *);
extern void parse_hostnetworkmask(char *, struct in_addr **, __u32 *, int *);
extern void parse_viahost(char *);
extern struct in_addr *parse_mask(char *);
extern void parse_all_ports(char **, unsigned short *, int, int);
extern unsigned short parse_port(char *);
extern void parse_vs_algorithm(char *);
extern void store_port(char *, unsigned short *, int, char *[]);
extern struct in_addr *network_to_addr(char *);
extern char *mask_to_dotted(__u32 *);
extern char * addr_to_dotted(__u32 *);
extern struct in_addr *dotted_to_addr(char *);
extern void exit_tryhelp(int);
extern void exit_error(int, char *);
extern struct in_addr * host_to_addr(char *, int *);
extern int service_to_port(char *);
extern char * port_to_service(int);
extern void exit_printhelp();
extern void check_option(long, char);
extern void inaddrcpy(struct in_addr *, struct in_addr *);
extern int do_setsockopt(int, void *, int);
extern void * nat_malloc(size_t);
extern void * nat_calloc(size_t, size_t);
extern int print_rule(struct ip_nat_set *);
extern int list_nat_rules();
